require "$path/GenFunc.pl";
sub GetCookies {
my ($SetGlobalVariable) = @_;
return %::Cookies if $::_CONST_GET_COOKIES;
$SetGlobalVariable = 1 unless defined $SetGlobalVariable;
my %cookies = ();
my @key_value_pairs = split (/;\s*/, $ENV{'COOKIE'}.$ENV{'HTTP_COOKIE'});
foreach my $pair (@key_value_pairs) {
my ($key, $value) = split(/=/, $pair);
$cookies{$key} = &UnEscape($value);
};
if ($SetGlobalVariable){
%::Cookies = %cookies;
$::_CONST_GET_COOKIES = 1;		
};
return %cookies;
};
sub	Cookie {
my ($name, $value, $expires, $path, $domain, $secure) = @_;
my $expires_date;
my %time_unit = (
s => 1,
h => 3600,
d => 86400,
w => 86400*7,
m => 86400*30,
y => 86400*365,
);
if ($expires =~ m/^(-?\d*?\.?\d+)(s|h|d|w|m|y)$/i) {
$expires_date = format_gmtdatetime(time + $1*$time_unit{lc($2)});
} else {
$expires_date = $expires;
};
($name, $value) = (&Escape($name), &Escape($value));
$secure = $secure ? ' secure' : '';
return "Set-Cookie: $name=$value; expires=$expires_date".($path?"; path\=$path":"").($domain?"; domain\=$domain":"")."$secure\n";
};
sub format_gmtdatetime {
my ($atime) = @_;
$atime ||= time;
my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
my @wdays = qw(Sun Mon Tue Wed Thu Fri Sat);
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($atime);
return sprintf("%s, %02d-%s-%s %02d:%02d:%02d GMT", $wdays[$wday], $mday, $months[$mon], $year+1900, $hour, $min, $sec);
};
1;