#!/usr/bin/perl5
%LOCK_HANDLES = ();
sub	LockFile {
my ($lockfile) = @_;
unless ($Use_flock){
my $endtime = time + 10;
my $delta = 20/86400; # 20 seconds
if (-e "$path/$lockfile" && -M "$path/$lockfile" > $delta) {
unlink("$path/$lockfile");
};
while (-e "$path/$lockfile" && time < $endtime) {
sleep(1);  # Wait 1 sec.
};
local *LOCK_FILE;
$LOCK_HANDLES{"$path/$lockfile"} = *LOCK_FILE;
open(LOCK_FILE, ">$path/$lockfile") || die("Error in sub LockFile: Can't open $path/$lockfile",$!);
};
};
sub	UnLockFile {
my ($lockfile) = @_;
unless ($Use_flock){
close($LOCK_HANDLES{"$path/$lockfile"});
unlink("$path/$lockfile") if (-e "$path/$lockfile");
};
};
sub	ReadFile {
my ($FilePath, $SaveTo, $LockFile) = @_;
my $res;
$LockFile = 0 unless defined $LockFile;
&LockFile("$path/$FilePath.lock") if $LockFile;
if ( open(RFILE, "<$path/$FilePath") ){
flock(RFILE, 2) if ($Use_flock && $LockFile);
if (defined $SaveTo){
if (ref($SaveTo) eq "SCALAR"){
{
local $/ = undef;
${$SaveTo} = <RFILE>;
$res = ${$SaveTo};
};
}
elsif (ref($struct) eq "ARRAY"){
@{$SaveTo} = <RFILE>;
}else{
{
local $/ = undef;
$res = <RFILE>;
};
}
}else{	# $SaveTo 
{
local $/ = undef;
$res = <RFILE>;
};
};
flock(RFILE, 8) if ($Use_flock && $LockFile);
close(RFILE);
&UnLockFile("$path/$FilePath.lock") if $LockFile;
}else{	# open failed
&UnLockFile("$path/$FilePath.lock") if $LockFile;
die("Cant open file $path/$FilePath in sub ReadFile!");
};
return $res;
};
sub	WriteFile {
my ($FilePath, $Data, $Append) = @_;
if ($Append){
open(FILE, ">>$path/$FilePath") || return 0;
} else {
open(FILE, ">$path/$FilePath") || return 0;
};	
if (ref($Data) eq "SCALAR"){
print FILE ${$Data};
}
elsif (ref($Data) eq "ARRAY"){
print FILE @{$Data};
} else {
print FILE $Data;
};
close(FILE);
return 1;
};
1;